Random123-1.09: r123::AESNI1xm128i Class Reference

- Random123-1.09 Documentation

Public Types | Public Member Functions | Static Public Attributes

# r123::AESNI1xm128i Class Reference
[ARS and AESNI Classes and Typedefs]

`#include <Random123/aes.h>`

Inheritance diagram for r123::AESNI1xm128i:

List of all members.

## Public Types
typedef aesni1xm128i_ctr_t | ctr_type
typedef aesni1xm128i_ukey_t | ukey_type
typedef aesni1xm128i_key_t | key_type
## Public Member Functions
ctr_type | operator() (ctr_type ctr, key_type key) const
## Static Public Attributes
static const unsigned int | rounds = 10

## Detailed Description

AESNI exports the member functions, typedefs and operator overloads required by a Counter Based RNGs (CBRNGs). class.

AESNI1xm128i uses the crypotgraphic AES round function, including the cryptographic key schedule.

In contrast to the other CBRNGs in the Random123 library, the AESNI1xm128i_R::key_type is opaque and is not identical to the AESNI1xm128i_R::ukey_type. Creating a key_type, using either the constructor or assignment operator, is significantly more time-consuming than running the bijection (hundreds of clock cycles vs. tens of clock cycles).

AESNI1xm128i is only available when the feature-test macro R123_USE_AES_NI is true, which should occur only when the compiler is configured to generate AES-NI instructions (or when defaults are overridden by compile-time, compiler-command-line options).

As of September 2011, the authors know of no statistical flaws with AESNI1xm128i. It would be an event of major cryptographic note if any such flaws were ever found.

## Member Typedef Documentation

typedef aesni1xm128i_ctr_t r123::AESNI1xm128i::ctr_type

typedef aesni1xm128i_key_t r123::AESNI1xm128i::key_type

typedef aesni1xm128i_ukey_t r123::AESNI1xm128i::ukey_type

## Member Function Documentation

ctr_type r123::AESNI1xm128i::operator() | ( | ctr_type | ctr,
|  | key_type | key |
| ) |  |  | const`[inline]`

## Member Data Documentation

const unsigned int r123::AESNI1xm128i::rounds = 10`[static]`

The documentation for this class was generated from the following file:

- Random123/aes.h

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines